#target InDesign
if (app.documents.length > 0) {
	var _dok = app.activeDocument;
	var _rulerOrigin = _dok.viewPreferences.rulerOrigin;
	_dok.viewPreferences.rulerOrigin = RulerOrigin.PAGE_ORIGIN;
	var _zeroPoint = _dok.zeroPoint;
	_dok.zeroPoint = [0,0];
	if (app.scriptPreferences.version >= 6 ) { // Ab CS4 Undo bereitstellen
		app.doScript(xmlImport, ScriptLanguage.JAVASCRIPT, _dok, UndoModes.ENTIRE_SCRIPT, "XMLImport"); 		
	} 
	else {
		xmlImport(_dok);
	}
	_dok.viewPreferences.rulerOrigin =_rulerOrigin;		
	_dok.zeroPoint = _zeroPoint;
} else {
	alert ("Kein Dokument geöffnet!")
}

function xmlImport (_dok) {
	_importMap = [];
	// Block-Elemente
	_importMap.push(["//body/p", "Grundtext", "block", "\r"]);
	_importMap.push(["//body/title[@class='h1']", "Überschrift1_erste", "block", "\r"]);
	_importMap.push(["//body/title[@class='h2']", "Überschrift2", "block", "\r"]);
	_importMap.push(["//body/ul/li", "Liste_Punkt", "block", "\r"]);
	_importMap.push(["//body/ul[@class='action']/li", "Handlung_einschrittig_erste", "block", "\r"]);
    _importMap.push(["//body/dl[@class='Liste_Strich']/dd", "Liste_Strich", "block", "\r"]);
    _importMap.push(["//body/dl[@class='Liste_Strich']/dt", "Grundtext", "block", "\r"]);
    _importMap.push(["//body/p[@class='tabellenAnker']", "tabellenAnker", "block", ""]);
    
    //Tabellen und Zellen
    _importMap.push(["//body/p[@class='tabellenAnker']/table", "Standard", "table", ""]);
    _importMap.push(["//body/p[@class='tabellenAnker']/table/cell", "Standard", "cell", ""]);
    _importMap.push(["//body/p[@class='tabellenAnker']/table/cell[@class='Warnhinweis_A']", "Warnhinweis_Kopf_GEFAHR", "cell", ""]);
    _importMap.push(["//body/p[@class='tabellenAnker']/table/cell[@class='Warnhinweis_B']", "Warnhinweis_Kopf_VORSICHT_WARNUNG", "cell", ""]);
    
    // Block-Elemente innerhalb von Tabellenzellen
    _importMap.push(["//body/p/table/cell/p[@class='Warnwort_A']", "Warnwort_GEFAHR_A", "block", "\r"]);
	_importMap.push(["//body/p/table/cell/p[@class='Warnwort_B']", "Warnwort_ACHTUNG_VORSICHT_WARNUNG_A", "block", "\r"]);
	_importMap.push(["//body/p/table/cell/p[@class='Tab_Text_links']", "Tab_Text_links", "block", "\r"]);
    


    // Inline-Elemente
	_importMap.push(["//body/span[@FORM='bold']", "fett", "inline", ""]);
	_importMap.push(["//body/span[@FORM='italic']", "kursiv", "inline", ""]);
    
	//Load XML File 
	var _xmlFile = File.openDialog ("Bitte wählen Sie die zu verarbeitende XML Datei aus", getFileFilter (".xml", "XML-Datei:"), false);
	if (_xmlFile == null) {
		alert ("Fehler bei Dateiauswahl!")
		return;
	}
	// Block-Elemente die nur Inline-Elemente enthalten maskieren 
	var _newXmlFile = saveWhiteSpace(_xmlFile, _importMap);	
	with (_dok.xmlImportPreferences)	{
		importStyle = XMLImportStyles.MERGE_IMPORT;
		createLinkToXML = false;		
		allowTransform = false;
		repeatTextElements = false;
		importTextIntoTables = false;
		ignoreWhitespace = true;		
		removeUnmatchedExisting = false;
		importCALSTables = false;
	}		
	_dok.importXML(_newXmlFile);	
	_newXmlFile.remove();		
	// Maskierung entfernen
	app.findGrepPreferences = NothingEnum.NOTHING;
	app.changeGrepPreferences = NothingEnum.NOTHING;
	app.findGrepPreferences.findWhat = "\\x{E000}";
	app.changeGrepPreferences.changeTo = "";
	_dok.xmlElements[0].changeGrep();	
	// Dokument formatieren 
	var _root = _dok.xmlElements[0];
    
    
    //weiter
	for (i = 0; i < _importMap.length; i++) {
		var _map = _importMap[i];
		var _xpath = _map[0];
		var node = null; 
		if (_map[2]== "block" ) _pStyle = getStyle(_map); 
		if (_map[2]== "inline" ) _cStyle = getStyle(_map); 
		if (_map[2]== "table" ) _tableStyle = getStyle(_map);
		if (_map[2]== "cell" ) _cellStyle = getStyle(_map);
		// Die eigentliche XML-Rule
		try { 
			var _proc = app.xmlRuleProcessors.add([_xpath]); 
			var _match = _proc.startProcessingRuleSet(_root); 
			while( _match!=undefined ) {
				_node = _match.element; 
	 	 		if (_map[2]== "block" ) {					
					_node.insertTextAsContent (_map[3], XMLElementPosition.afterElement);
					_node.applyParagraphStyle(_pStyle);
				} 
				if (_map[2]== "inline" ) {
					_node.insertTextAsContent (_map[3], XMLElementPosition.afterElement);
					_node.applyCharacterStyle (_cStyle);
				} /* von mir */
                if (_map[2]== "table" ) {
                    _node.insertTextAsContent (_map[3], XMLElementPosition.afterElement);
					_node.applyTableStyle (_tableStyle);
				}
                if (_map[2]== "cell" ) {
                    _node.insertTextAsContent (_map[3], XMLElementPosition.afterElement);
					_node.applyCellStyle (_cellStyle);
				}
				_match = _proc.findNextMatch(); 
			}
		}			
		catch(e) { 
			throw (e); 
		} finally { 
			_proc.endProcessingRuleSet(); 
			_proc.remove(); 
		} 
	} // end for 	
	// Bereinigung von Absätzen am Ende der Story
	app.findGrepPreferences.findWhat = "\\r\\Z";
	app.changeGrepPreferences.changeTo = "";
	_dok.changeGrep();
	app.findGrepPreferences = NothingEnum.NOTHING;
	app.changeGrepPreferences = NothingEnum.NOTHING;
    
    // weitere Funktionsaufrufe
    xmlElementeUmformen ();
    leereAbsaetzeRaus ();
    FussnotenAbsatzKorrektur ();
}

// Save Whitespace in Blocklevel
function saveWhiteSpace(_xmlFile, _importMap) {
	_xmlFile.encoding = "UTF8";
	_xmlFile .open("r");
	_text = _xmlFile .read();
	_xmlFile.close();
	for (var i = 0; i < _importMap.length; i++) {
		var _tagName = _importMap[i][0].substring (_importMap[i][0].lastIndexOf ("/")+1);
		var _re = RegExp ("(<\\/" + _tagName + ">)", "g");
		_text =_text.replace (_re, "\uE000$1");
	}	
	// Set Properties;
	// Neue XML-Datei mit Properties schreiben ...
	_newXmlFile = File (_xmlFile.path + "/idimport_" + _xmlFile.name)
	_newXmlFile.open("w");
	_newXmlFile.encoding = "UTF8";
	// unicode signature, this is UTF16 but will convert to UTF8 "EF BB BF"
	_xmlFile.write("\uFEFF");
	_xmlFile.lineFeed = "unix";
	_newXmlFile.write(_text);
	_newXmlFile.close();	
	return _newXmlFile;
}

function getStyle (_map) {
	if (_map[2]== "block" ) {
		for (var i = 0; i < _dok.allParagraphStyles.length; i++) {
			if (_dok.allParagraphStyles[i].name == _map[1]) {
				return _dok.allParagraphStyles[i];
			}
		}
		// Style muss erstellt werden 
		return app.activeDocument.paragraphStyles.add({name:_map[1]});
	} 
	if (_map[2]== "inline" ) {
		for (var i = 0; i < _dok.characterStyles.length; i++) {
			if (_dok.characterStyles[i].name == _map[1] ) {
				return _dok.characterStyles[i];
			}
		}
		// Style muss erstellt werden 
		return app.activeDocument.characterStyles.add({name:_map[1]});
	}
    // weitervonMir
    if (_map[2]== "table" ) {
		for (var i = 0; i < _dok.tableStyles.length; i++) {
			if (_dok.tableStyles[i].name == _map[1] ) {
				return _dok.tableStyles[i];
			}
		}
		// Style muss erstellt werden 
		return app.activeDocument.tableStyles.add({name:_map[1]});
	}
    
    if (_map[2]== "cell" ) {
		for (var i = 0; i < _dok.cellStyles.length; i++) {
			if (_dok.cellStyles[i].name == _map[1] ) {
				return _dok.cellStyles[i];
			}
		}
		// Style muss erstellt werden 
		return app.activeDocument.cellStyles.add({name:_map[1]});
	}
    
    
}

// 2018-06-04
function leereAbsaetzeRaus () {
    try  
    { 
        app.loadFindChangeQuery ('leereAbsaetzeRaus', SearchModes.grepSearch);  
        app.activeDocument.changeGrep();  
    } catch(e) {}
    return;
}

function FussnotenAbsatzKorrektur () {
    try  
    { 
        app.loadFindChangeQuery ('FussnotenAbsatzKorrektur', SearchModes.grepSearch);  
        app.activeDocument.changeGrep();  
    } catch(e) {}
    return;
}

// Filter für Dateiauswahl 
function getFileFilter (_ext, _string) {
	if (File.fs == "Windows") {
		var _filter = _string + "*"+ _ext;
	} 
	else {
		function _filterFilesMac(file) {
			while (file.alias) {
				file = file.resolve();
				if (file == null) { return false }
			}
			if (file.constructor.name == "Folder") return true;
			var _extension = file.name.toLowerCase().slice(file.name.lastIndexOf("."));
			if (_extension.indexOf (_ext) > -1 ) return true;
			else return false
		}
		var _filter = _filterFilesMac;
	} 
	return _filter;
}

// hinzugefügt 2018-06-04 formt fn-XML-Elemente zu Fußnoten um 
function xmlElementeUmformen () {
    var root = app.activeDocument.xmlElements[0];
    // XPath auswerten und in Variable speichern

    var footnotes = root.evaluateXPathExpression("//p/fn"); 
    // über Fussnoten iterieren
    for (i = 0; i < footnotes.length; i++) {
        var currentElement = footnotes[i];
        var fnText = currentElement.contents;
        var fnCharRange = currentElement.parentStory.characters.itemByRange(currentElement.insertionPoints[1].index, currentElement.insertionPoints[-1].index);
        var fNote = currentElement.insertionPoints[0].footnotes.add();
        fNote.insertionPoints[-1].contents = fnText;
        fnCharRange.remove();
    }
    return;
}